>From 4faf81231d4ace22932565119a8c59465c7f9b4e Mon Sep 17 00:00:00 2001
From: Yuri Chornoivan <yurchor@ukr.net>
Date: Sat, 9 Dec 2017 20:32:41 +0200
Subject: [PATCH] Fix minor typos

---
 src/qemu/qemu_domain.c   | 6 +++---
 src/xen/xen_hypervisor.c | 4 ++--
 src/xen/xend_internal.c  | 4 ++--
 3 files changed, 7 insertions(+), 7 deletions(-)

diff --git a/src/qemu/qemu_domain.c b/src/qemu/qemu_domain.c
index d7150cae1..7197cfdf8 100644
--- a/src/qemu/qemu_domain.c
+++ b/src/qemu/qemu_domain.c
@@ -3694,7 +3694,7 @@ qemuDomainWatchdogDefValidate(const virDomainWatchdogDef *dev,
         if (dev->info.type != VIR_DOMAIN_DEVICE_ADDRESS_TYPE_NONE &&
             dev->info.type != VIR_DOMAIN_DEVICE_ADDRESS_TYPE_PCI) {
             virReportError(VIR_ERR_CONFIG_UNSUPPORTED,
-                           _("%s model of watchog can go only on PCI bus"),
+                           _("%s model of watchdog can go only on PCI bus"),
                            virDomainWatchdogModelTypeToString(dev->model));
             return -1;
         }
@@ -3704,7 +3704,7 @@ qemuDomainWatchdogDefValidate(const virDomainWatchdogDef *dev,
         if (dev->info.type != VIR_DOMAIN_DEVICE_ADDRESS_TYPE_NONE &&
             dev->info.type != VIR_DOMAIN_DEVICE_ADDRESS_TYPE_ISA) {
             virReportError(VIR_ERR_CONFIG_UNSUPPORTED,
-                           _("%s model of watchog can go only on ISA bus"),
+                           _("%s model of watchdog can go only on ISA bus"),
                            virDomainWatchdogModelTypeToString(dev->model));
             return -1;
         }
@@ -3713,7 +3713,7 @@ qemuDomainWatchdogDefValidate(const virDomainWatchdogDef *dev,
     case VIR_DOMAIN_WATCHDOG_MODEL_DIAG288:
         if (dev->info.type != VIR_DOMAIN_DEVICE_ADDRESS_TYPE_NONE) {
             virReportError(VIR_ERR_CONFIG_UNSUPPORTED,
-                           _("%s model of watchog is virtual and cannot go on any bus."),
+                           _("%s model of watchdog is virtual and cannot go on any bus."),
                            virDomainWatchdogModelTypeToString(dev->model));
             return -1;
         }
diff --git a/src/xen/xen_hypervisor.c b/src/xen/xen_hypervisor.c
index 633ec9eee..4621507eb 100644
--- a/src/xen/xen_hypervisor.c
+++ b/src/xen/xen_hypervisor.c
@@ -1263,7 +1263,7 @@ xenHypervisorGetSchedulerParameters(virConnectPtr conn,
 
                 /* TODO: Implement for Xen/SEDF */
                 virReportError(VIR_ERR_CONFIG_UNSUPPORTED, "%s",
-                               _("SEDF schedular parameters not supported"));
+                               _("SEDF scheduler parameters not supported"));
                 return -1;
             case XEN_SCHEDULER_CREDIT:
                 memset(&op_dom, 0, sizeof(op_dom));
@@ -1361,7 +1361,7 @@ xenHypervisorSetSchedulerParameters(virConnectPtr conn,
         case XEN_SCHEDULER_SEDF:
             /* TODO: Implement for Xen/SEDF */
             virReportError(VIR_ERR_CONFIG_UNSUPPORTED, "%s",
-                           _("SEDF schedular parameters not supported"));
+                           _("SEDF scheduler parameters not supported"));
             return -1;
         case XEN_SCHEDULER_CREDIT: {
             memset(&op_dom, 0, sizeof(op_dom));
diff --git a/src/xen/xend_internal.c b/src/xen/xend_internal.c
index e4edfd6f8..b3178b7be 100644
--- a/src/xen/xend_internal.c
+++ b/src/xen/xend_internal.c
@@ -2871,7 +2871,7 @@ xenDaemonGetSchedulerParameters(virConnectPtr conn,
 
             /* TODO: Implement for Xen/SEDF */
             virReportError(VIR_ERR_CONFIG_UNSUPPORTED, "%s",
-                           _("SEDF schedular parameters not supported"));
+                           _("SEDF scheduler parameters not supported"));
             goto error;
         case XEN_SCHED_CRED_NPARAM:
             /* get cpu_weight/cpu_cap from xend/domain */
@@ -2963,7 +2963,7 @@ xenDaemonSetSchedulerParameters(virConnectPtr conn,
         case XEN_SCHED_SEDF_NPARAM:
             /* TODO: Implement for Xen/SEDF */
             virReportError(VIR_ERR_CONFIG_UNSUPPORTED, "%s",
-                           _("SEDF schedular parameters not supported"));
+                           _("SEDF scheduler parameters not supported"));
             goto error;
         case XEN_SCHED_CRED_NPARAM: {
             char buf_weight[VIR_UUID_BUFLEN];
-- 
2.13.6